#include <stdio.h>


//#undef  pathcrawler_label
//#define pathcrawler_label(cond)   {} // DSE(p)
//#define pathcrawler_label(cond)   { if(cond) {printf("\nlabelCondTrue('%s:%d')\n",__FILE__, __LINE__);} } // DSE(p')
// DSE(p*) tout commenter + disable_label_history(yes)
// DSE*(p*) tout commenter


#define OLEV       600		/* in feets/minute */
#define MAXALTDIFF 600		/* max altitude difference in feet */
#define MINSEP     300          /* min separation in feet */
#define NOZCROSS   100		/* in feet */

typedef int bool;

int Cur_Vertical_Sep;
bool High_Confidence;		/* 1/0 */
bool Two_of_Three_Reports_Valid;		/* 1/0 */
int Own_Tracked_Alt;
int Own_Tracked_Alt_Rate;
int Other_Tracked_Alt;
int Alt_Layer_Value;		/* 0, 1, 2, 3 */
int Positive_RA_Alt_Thresh[4];
int Up_Separation;
int Down_Separation;
int Other_RAC;			/* NO_INTENT, DO_NOT_CLIMB, DO_NOT_DESCEND */
#define NO_INTENT 0
#define DO_NOT_CLIMB 1
#define DO_NOT_DESCEND 2
int Other_Capability;		/* TCAS_TA, OTHER */
#define TCAS_TA 1
#define OTHER 2
int Climb_Inhibit;
#define UNRESOLVED 0
#define UPWARD_RA 1
#define DOWNWARD_RA 2




bool Own_Below_Threat();
bool Own_Above_Threat();


void initialize(){

    Positive_RA_Alt_Thresh[0] = 400;
    Positive_RA_Alt_Thresh[1] = 500;
    Positive_RA_Alt_Thresh[2] = 640;
    Positive_RA_Alt_Thresh[3] = 740;
}


int ALIM (){

  pathcrawler_label(Alt_Layer_Value != 0); 

 return Positive_RA_Alt_Thresh[Alt_Layer_Value];
}



int Inhibit_Biased_Climb (){


  pathcrawler_label(Climb_Inhibit >= 1); 
  pathcrawler_label(Climb_Inhibit > 1); 
  pathcrawler_label(Climb_Inhibit <= 1); 
  pathcrawler_label(Climb_Inhibit < 1); 
  pathcrawler_label(1); 


	    	if(Climb_Inhibit == 1){


		  pathcrawler_label((Up_Separation + NOZCROSS) != (Up_Separation * NOZCROSS));
		  pathcrawler_label((Up_Separation + NOZCROSS) != (Up_Separation / NOZCROSS));
		  pathcrawler_label((Up_Separation + NOZCROSS) != (Up_Separation % NOZCROSS));
		  pathcrawler_label((Up_Separation + NOZCROSS) != (Up_Separation - NOZCROSS));
 

	    		return (Up_Separation + NOZCROSS);
	    	}
	    	else{

		  pathcrawler_label(Up_Separation != 0);

	    		return (Up_Separation);
	    	}
}



bool Non_Crossing_Biased_Climb(){
    int upward_preferred;
    bool result;


    int aux_int1 = Inhibit_Biased_Climb(); 
    bool aux_bool1; 
    int aux_int2; 


    pathcrawler_label(aux_int1 == Down_Separation);
    pathcrawler_label(aux_int1 != Down_Separation);
    pathcrawler_label(1);
    pathcrawler_label(aux_int1 >= Down_Separation);
    pathcrawler_label(aux_int1 < Down_Separation);
 

    upward_preferred = aux_int1 > Down_Separation;
    if (upward_preferred)
    {


      aux_bool1 = Own_Below_Threat(); 
      aux_int2 = ALIM(); 

      pathcrawler_label(aux_bool1 && Down_Separation == aux_int2 );
      pathcrawler_label(aux_bool1 && 1);
      pathcrawler_label(aux_bool1 && Down_Separation != aux_int2);
      pathcrawler_label(aux_bool1 && Down_Separation > aux_int2 );
      pathcrawler_label(aux_bool1 && Down_Separation <= aux_int2 );


      pathcrawler_label(aux_bool1 && (Down_Separation >= aux_int2));
      pathcrawler_label(aux_bool1);
      pathcrawler_label((!aux_bool1 && (!aux_bool1 || (Down_Separation >= aux_int2))) || (aux_bool1 && (aux_bool1 && (Down_Separation < aux_int2))) );
      pathcrawler_label(!(aux_bool1) && ((aux_bool1) && ((Down_Separation < aux_int2))));



	result = !aux_bool1 || (aux_bool1 && !(Down_Separation >= aux_int2));
    }
    else
    {	

 
      aux_bool1 = Own_Above_Threat(); 
      aux_int2 = ALIM();


      pathcrawler_label( aux_bool1 && (Up_Separation >= aux_int2) && Cur_Vertical_Sep == MINSEP );
      pathcrawler_label( aux_bool1 && (Up_Separation >= aux_int2) && 1 );
      pathcrawler_label( aux_bool1 && (Up_Separation >= aux_int2) && Cur_Vertical_Sep != MINSEP );
      pathcrawler_label( aux_bool1 && (Up_Separation >= aux_int2) && Cur_Vertical_Sep > MINSEP );
      pathcrawler_label( aux_bool1 && (Up_Separation >= aux_int2) && Cur_Vertical_Sep <= MINSEP );

      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Up_Separation == aux_int2  );
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && 1  );
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Up_Separation != aux_int2  );
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Up_Separation > aux_int2  );
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Up_Separation <= aux_int2  );
 

      pathcrawler_label((!aux_bool1 && ((Cur_Vertical_Sep >= MINSEP) && (Up_Separation >= aux_int2))) || (aux_bool1 && ((Cur_Vertical_Sep < MINSEP) || (Up_Separation < aux_int2))) );
      pathcrawler_label( (aux_bool1 || (Cur_Vertical_Sep >= MINSEP)) && (Up_Separation >= aux_int2) );
      pathcrawler_label( ((!aux_bool1 || (Cur_Vertical_Sep < MINSEP)) && (Up_Separation >= aux_int2)) || ((aux_bool1 && (Cur_Vertical_Sep >= MINSEP)) && (Up_Separation < aux_int2)) );
      pathcrawler_label( aux_bool1 && ((Cur_Vertical_Sep >= MINSEP) || (Up_Separation >= aux_int2)) );
      




	result = aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && (Up_Separation >= aux_int2);
    }
    return result;
}

bool Non_Crossing_Biased_Descend(){
    int upward_preferred;
    bool result;



    int aux_int1 = Inhibit_Biased_Climb(); 


    pathcrawler_label(aux_int1 == Down_Separation);
    pathcrawler_label(aux_int1 != Down_Separation);
    pathcrawler_label(1);
    pathcrawler_label(aux_int1 > Down_Separation);
    pathcrawler_label(aux_int1 < Down_Separation);
 
   


    upward_preferred = aux_int1 > Down_Separation;
    if (upward_preferred)
    {



      bool aux_bool1 = Own_Below_Threat(); 
      int aux_int2 = ALIM(); 


      pathcrawler_label( aux_bool1 && (Down_Separation >= aux_int2) && Cur_Vertical_Sep == MINSEP );
      pathcrawler_label( aux_bool1 && (Down_Separation >= aux_int2) && 1 );
      pathcrawler_label( aux_bool1 && (Down_Separation >= aux_int2) && Cur_Vertical_Sep != MINSEP );
      pathcrawler_label( aux_bool1 && (Down_Separation >= aux_int2) && Cur_Vertical_Sep > MINSEP);
      pathcrawler_label( aux_bool1 && (Down_Separation >= aux_int2) && Cur_Vertical_Sep <= MINSEP );


      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Down_Separation == aux_int2  ); 
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && 1  ); 
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Down_Separation != aux_int2  ); 
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Down_Separation > aux_int2  ); 
      pathcrawler_label( aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && Down_Separation <= aux_int2  ); 


      pathcrawler_label( (!aux_bool1 && (Cur_Vertical_Sep >= MINSEP && Down_Separation >= aux_int2)) || (aux_bool1 && !(Cur_Vertical_Sep >= MINSEP && Down_Separation >= aux_int2)) );
      pathcrawler_label( (aux_bool1 || Cur_Vertical_Sep >= MINSEP) && Down_Separation >= aux_int2 );
      pathcrawler_label( (!(aux_bool1 && (Cur_Vertical_Sep >= MINSEP)) && (Down_Separation >= aux_int2)) || ((aux_bool1 && (Cur_Vertical_Sep >= MINSEP)) && !(Down_Separation >= aux_int2)) );
      pathcrawler_label( aux_bool1 && ((Cur_Vertical_Sep >= MINSEP) || (Down_Separation >= aux_int2))  );


	result = aux_bool1 && (Cur_Vertical_Sep >= MINSEP) && (Down_Separation >= aux_int2);
    }
    else
    {

      int aux_int3 = ALIM(); 
      bool aux_bool2 = Own_Above_Threat(); 


      pathcrawler_label(aux_bool2 && Up_Separation == aux_int3);
      pathcrawler_label(aux_bool2 && 1);
      pathcrawler_label(aux_bool2 && Up_Separation != aux_int3);
      pathcrawler_label(aux_bool2 && Up_Separation > aux_int3);
      pathcrawler_label(aux_bool2 && Up_Separation <= aux_int3);
      pathcrawler_label( (aux_bool2) && (Up_Separation < aux_int3) );
      pathcrawler_label( aux_bool2 );
      pathcrawler_label( (aux_bool2 && (aux_bool2 && Up_Separation >= aux_int3)) || (!aux_bool2 && (!aux_bool2 || Up_Separation < aux_int3)) );
      pathcrawler_label( !(aux_bool2) && (aux_bool2 && Up_Separation >= aux_int3) );



	result = !(aux_bool2) || ((aux_bool2) && (Up_Separation >= aux_int3));
    }
    return result;
}

bool Own_Below_Threat(){
    //return (Own_Tracked_Alt < Other_Tracked_Alt);
    if(Own_Tracked_Alt < Other_Tracked_Alt){
    	return 1;
    }
    else{
    	return 0;
    }
}

bool Own_Above_Threat(){
    //return (Other_Tracked_Alt < Own_Tracked_Alt);
	if(Other_Tracked_Alt < Own_Tracked_Alt){
		return 1;
	}
	else{
		return 0;
	}
}

/*@ requires Alt_Layer_Value >= 0 && Alt_Layer_Value <= 3 ;
  @ requires High_Confidence >= 0 && High_Confidence <= 1 ;
  @ requires Two_of_Three_Reports_Valid >= 0 && Two_of_Three_Reports_Valid <= 1 ;
  @ requires High_Confidence >= 0 && High_Confidence <= 1 ;
  @*/
int alt_sep_test()     // function under test
{
    bool enabled, tcas_equipped, intent_not_known;
    bool need_upward_RA, need_downward_RA;
    int alt_sep;


    pathcrawler_assume(0 <= Alt_Layer_Value);  pathcrawler_assume(Alt_Layer_Value <= 3); 

    initialize(); 



    pathcrawler_label( (High_Confidence==1) && (Cur_Vertical_Sep > MAXALTDIFF)   &&  1);
    pathcrawler_label( (High_Confidence==1) && (Cur_Vertical_Sep > MAXALTDIFF)   &&  Own_Tracked_Alt_Rate != OLEV );
    pathcrawler_label( (High_Confidence==1) && (Cur_Vertical_Sep > MAXALTDIFF)   &&  Own_Tracked_Alt_Rate == OLEV);
    pathcrawler_label( (High_Confidence==1) && (Cur_Vertical_Sep > MAXALTDIFF)   &&  Own_Tracked_Alt_Rate < OLEV );
    pathcrawler_label( (High_Confidence==1) && (Cur_Vertical_Sep > MAXALTDIFF)   &&  Own_Tracked_Alt_Rate >= OLEV);


    pathcrawler_label( High_Confidence && (Own_Tracked_Alt_Rate <= OLEV) &&  Cur_Vertical_Sep == MAXALTDIFF );
    pathcrawler_label( High_Confidence && (Own_Tracked_Alt_Rate <= OLEV) &&  Cur_Vertical_Sep != MAXALTDIFF );
    pathcrawler_label( High_Confidence && (Own_Tracked_Alt_Rate <= OLEV) &&  1 );
    pathcrawler_label( High_Confidence && (Own_Tracked_Alt_Rate <= OLEV) &&  Cur_Vertical_Sep > MAXALTDIFF );
    pathcrawler_label( High_Confidence && (Own_Tracked_Alt_Rate <= OLEV) &&  Cur_Vertical_Sep < MAXALTDIFF );


    pathcrawler_label(Other_Capability >= TCAS_TA);
    pathcrawler_label(Other_Capability > TCAS_TA);
    pathcrawler_label(Other_Capability <= TCAS_TA);
    pathcrawler_label(Other_Capability < TCAS_TA);
    pathcrawler_label(1);


    pathcrawler_label(Two_of_Three_Reports_Valid && Other_RAC >= NO_INTENT );
    pathcrawler_label(Two_of_Three_Reports_Valid && Other_RAC > NO_INTENT );
    pathcrawler_label(Two_of_Three_Reports_Valid && Other_RAC <= NO_INTENT );
    pathcrawler_label(Two_of_Three_Reports_Valid && Other_RAC < NO_INTENT );
    pathcrawler_label(Two_of_Three_Reports_Valid && 1 );



    pathcrawler_label( (High_Confidence && ((Own_Tracked_Alt_Rate > OLEV) || (Cur_Vertical_Sep <= MAXALTDIFF))) || (!High_Confidence && ((Own_Tracked_Alt_Rate <= OLEV) && (Cur_Vertical_Sep > MAXALTDIFF))) );
    pathcrawler_label( (High_Confidence || (Own_Tracked_Alt_Rate <= OLEV)) && (Cur_Vertical_Sep > MAXALTDIFF)  );
    pathcrawler_label( ((High_Confidence && (Own_Tracked_Alt_Rate <= OLEV)) && (Cur_Vertical_Sep <= MAXALTDIFF)) || ((!High_Confidence || (Own_Tracked_Alt_Rate > OLEV)) && (Cur_Vertical_Sep > MAXALTDIFF)) );
    pathcrawler_label( High_Confidence && ((Own_Tracked_Alt_Rate <= OLEV) || (Cur_Vertical_Sep > MAXALTDIFF))  );
    pathcrawler_label( (Two_of_Three_Reports_Valid && (Other_RAC != NO_INTENT)) || (!Two_of_Three_Reports_Valid && (Other_RAC == NO_INTENT)) );
    pathcrawler_label( Two_of_Three_Reports_Valid || Other_RAC == NO_INTENT );




    enabled = High_Confidence && (Own_Tracked_Alt_Rate <= OLEV) && (Cur_Vertical_Sep > MAXALTDIFF);
    tcas_equipped = Other_Capability == TCAS_TA;
    intent_not_known = Two_of_Three_Reports_Valid && Other_RAC == NO_INTENT;
    


    pathcrawler_label(UNRESOLVED != 0);

    alt_sep = UNRESOLVED;
    

    pathcrawler_label(enabled && tcas_equipped && !intent_not_known );
    pathcrawler_label(enabled && tcas_equipped);
    pathcrawler_label( enabled && (((tcas_equipped && intent_not_known) && tcas_equipped) || ( !tcas_equipped)) );
    pathcrawler_label(enabled && ((tcas_equipped && intent_not_known) && !tcas_equipped) );
    pathcrawler_label((enabled && !((tcas_equipped && intent_not_known) || !tcas_equipped)) || (!enabled && ((tcas_equipped && intent_not_known) || !tcas_equipped)) );
    pathcrawler_label( enabled || ((tcas_equipped && intent_not_known) || !tcas_equipped) );
    




    if (enabled && ((tcas_equipped && intent_not_known) || !tcas_equipped))
    {


      bool aux_bool1 = Non_Crossing_Biased_Climb(); 
      bool aux_bool2 = Own_Below_Threat();
      bool aux_bool3 = Non_Crossing_Biased_Descend(); 
      bool aux_bool4 = Own_Above_Threat();


      pathcrawler_label((aux_bool1 && !aux_bool2) || (!aux_bool1 && aux_bool2));
      pathcrawler_label(aux_bool1 || aux_bool2);
      pathcrawler_label((aux_bool3 && !aux_bool4) || (!aux_bool3 && aux_bool4));
      pathcrawler_label(aux_bool3 || aux_bool4);


	need_upward_RA = aux_bool1 && aux_bool2;
	need_downward_RA = aux_bool3 && aux_bool4;



	pathcrawler_label((need_upward_RA && !need_downward_RA) || (!need_upward_RA && need_downward_RA));
	pathcrawler_label(need_upward_RA || need_downward_RA);
	


	if (need_upward_RA && need_downward_RA){

	  pathcrawler_label(UNRESOLVED != 0);

        /* unreachable: requires Own_Below_Threat and Own_Above_Threat
           to both be 1 - that requires Own_Tracked_Alt < Other_Tracked_Alt
           and Other_Tracked_Alt < Own_Tracked_Alt, which isn't possible */
	    alt_sep = UNRESOLVED;
	}
	else if (need_upward_RA){

	  pathcrawler_label(UPWARD_RA != 0);

	    alt_sep = UPWARD_RA;
	}
	else if (need_downward_RA){

	  pathcrawler_label(DOWNWARD_RA != 0);

	    alt_sep = DOWNWARD_RA;
	}
	else{

	  pathcrawler_label(UNRESOLVED != 0);

	    alt_sep = UNRESOLVED;
    }
    }


    pathcrawler_label(alt_sep != 0);

    
    return alt_sep;
}
